import { utils, Contract } from 'ethers';

/* Autogenerated file. Do not edit manually. */
const _abi = [{
  anonymous: false,
  inputs: [{
    indexed: true,
    internalType: "address",
    name: "extensionAddress",
    type: "address"
  }, {
    indexed: true,
    internalType: "bytes4",
    name: "functionSelector",
    type: "bytes4"
  }, {
    indexed: false,
    internalType: "string",
    name: "functionSignature",
    type: "string"
  }],
  name: "ExtensionAdded",
  type: "event"
}, {
  anonymous: false,
  inputs: [{
    indexed: true,
    internalType: "address",
    name: "extensionAddress",
    type: "address"
  }, {
    indexed: true,
    internalType: "bytes4",
    name: "functionSelector",
    type: "bytes4"
  }, {
    indexed: false,
    internalType: "string",
    name: "functionSignature",
    type: "string"
  }],
  name: "ExtensionRemoved",
  type: "event"
}, {
  anonymous: false,
  inputs: [{
    indexed: true,
    internalType: "address",
    name: "oldExtensionAddress",
    type: "address"
  }, {
    indexed: true,
    internalType: "address",
    name: "newExtensionAddress",
    type: "address"
  }, {
    indexed: true,
    internalType: "bytes4",
    name: "functionSelector",
    type: "bytes4"
  }, {
    indexed: false,
    internalType: "string",
    name: "functionSignature",
    type: "string"
  }],
  name: "ExtensionUpdated",
  type: "event"
}, {
  stateMutability: "payable",
  type: "fallback"
}, {
  inputs: [{
    internalType: "string",
    name: "_extensionName",
    type: "string"
  }],
  name: "addExtension",
  outputs: [],
  stateMutability: "nonpayable",
  type: "function"
}, {
  inputs: [],
  name: "defaultExtensionSet",
  outputs: [{
    internalType: "address",
    name: "",
    type: "address"
  }],
  stateMutability: "view",
  type: "function"
}, {
  inputs: [],
  name: "extensionRegistry",
  outputs: [{
    internalType: "address",
    name: "",
    type: "address"
  }],
  stateMutability: "view",
  type: "function"
}, {
  inputs: [],
  name: "getAllExtensions",
  outputs: [{
    components: [{
      components: [{
        internalType: "string",
        name: "name",
        type: "string"
      }, {
        internalType: "string",
        name: "metadataURI",
        type: "string"
      }, {
        internalType: "address",
        name: "implementation",
        type: "address"
      }],
      internalType: "struct IExtension.ExtensionMetadata",
      name: "metadata",
      type: "tuple"
    }, {
      components: [{
        internalType: "bytes4",
        name: "functionSelector",
        type: "bytes4"
      }, {
        internalType: "string",
        name: "functionSignature",
        type: "string"
      }],
      internalType: "struct IExtension.ExtensionFunction[]",
      name: "functions",
      type: "tuple[]"
    }],
    internalType: "struct IExtension.Extension[]",
    name: "allExtensions",
    type: "tuple[]"
  }],
  stateMutability: "view",
  type: "function"
}, {
  inputs: [{
    internalType: "string",
    name: "_extensionName",
    type: "string"
  }],
  name: "getAllFunctionsOfExtension",
  outputs: [{
    components: [{
      internalType: "bytes4",
      name: "functionSelector",
      type: "bytes4"
    }, {
      internalType: "string",
      name: "functionSignature",
      type: "string"
    }],
    internalType: "struct IExtension.ExtensionFunction[]",
    name: "",
    type: "tuple[]"
  }],
  stateMutability: "view",
  type: "function"
}, {
  inputs: [{
    internalType: "string",
    name: "_extensionName",
    type: "string"
  }],
  name: "getExtension",
  outputs: [{
    components: [{
      components: [{
        internalType: "string",
        name: "name",
        type: "string"
      }, {
        internalType: "string",
        name: "metadataURI",
        type: "string"
      }, {
        internalType: "address",
        name: "implementation",
        type: "address"
      }],
      internalType: "struct IExtension.ExtensionMetadata",
      name: "metadata",
      type: "tuple"
    }, {
      components: [{
        internalType: "bytes4",
        name: "functionSelector",
        type: "bytes4"
      }, {
        internalType: "string",
        name: "functionSignature",
        type: "string"
      }],
      internalType: "struct IExtension.ExtensionFunction[]",
      name: "functions",
      type: "tuple[]"
    }],
    internalType: "struct IExtension.Extension",
    name: "",
    type: "tuple"
  }],
  stateMutability: "view",
  type: "function"
}, {
  inputs: [{
    internalType: "bytes4",
    name: "_functionSelector",
    type: "bytes4"
  }],
  name: "getExtensionForFunction",
  outputs: [{
    components: [{
      internalType: "string",
      name: "name",
      type: "string"
    }, {
      internalType: "string",
      name: "metadataURI",
      type: "string"
    }, {
      internalType: "address",
      name: "implementation",
      type: "address"
    }],
    internalType: "struct IExtension.ExtensionMetadata",
    name: "",
    type: "tuple"
  }],
  stateMutability: "view",
  type: "function"
}, {
  inputs: [{
    internalType: "string",
    name: "_extensionName",
    type: "string"
  }],
  name: "getExtensionImplementation",
  outputs: [{
    internalType: "address",
    name: "",
    type: "address"
  }],
  stateMutability: "view",
  type: "function"
}, {
  inputs: [{
    internalType: "bytes4",
    name: "_functionSelector",
    type: "bytes4"
  }],
  name: "getImplementationForFunction",
  outputs: [{
    internalType: "address",
    name: "extensionAddress",
    type: "address"
  }],
  stateMutability: "view",
  type: "function"
}, {
  inputs: [{
    internalType: "bytes[]",
    name: "data",
    type: "bytes[]"
  }],
  name: "multicall",
  outputs: [{
    internalType: "bytes[]",
    name: "results",
    type: "bytes[]"
  }],
  stateMutability: "nonpayable",
  type: "function"
}, {
  inputs: [{
    internalType: "string",
    name: "_extensionName",
    type: "string"
  }],
  name: "removeExtension",
  outputs: [],
  stateMutability: "nonpayable",
  type: "function"
}, {
  inputs: [{
    internalType: "bytes4",
    name: "interfaceId",
    type: "bytes4"
  }],
  name: "supportsInterface",
  outputs: [{
    internalType: "bool",
    name: "",
    type: "bool"
  }],
  stateMutability: "view",
  type: "function"
}, {
  inputs: [{
    internalType: "string",
    name: "_extensionName",
    type: "string"
  }],
  name: "updateExtension",
  outputs: [],
  stateMutability: "nonpayable",
  type: "function"
}];
class TWRouter__factory {
  static abi = _abi;
  static createInterface() {
    return new utils.Interface(_abi);
  }
  static connect(address, signerOrProvider) {
    return new Contract(address, _abi, signerOrProvider);
  }
}

export { TWRouter__factory };
